/*	libmsgenabler - Library of messaging enabler
 *
 *	Authors: WU Yu <yu.wu@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#ifndef LIPS_MSG_TYPES_H
#define LIPS_MSG_TYPES_H


#include <stdint.h>
#include <time.h>

#ifdef __cplusplus
extern "C"
{
#endif                          /* __cplusplus */


  typedef uint32_t msg_sid_t;
  typedef time_t msg_time_t;
  typedef uint32_t msg_msgid_t;
  typedef uint32_t msg_msgsid_t;
  typedef uint32_t msg_size_t;


  typedef struct _msg_message_t msg_message_t;



  typedef uint32_t msg_fid_t;


/**
 *@brief: definition of msg_message_type_t
 * The enumeration includes:
 *    	 
 */
  typedef enum
  {
    MSG_SMS = 1,
    MSG_EMS,
    MSG_MMS,
    MSG_EMAIL,
    MSG_VOICEMAIL,
    MSG_IM,
  } msg_type_t;

  typedef enum
  {
    MSG_MEM_ME,
    MSG_MEM_SIM,
  } msg_mem_t;


  typedef enum
  {
    MSG_RECEIVED_UNREAD = 1,
    MSG_RECEIVED_READ,
    MSG_RECEIVED_REPLIED,
    MSG_RECEIVED_FORWARDED,

    MSG_SENDING,
    MSG_SENT_FAILED,
    MSG_SENT,
    MSG_SENT_CONFIRMED,

    MSG_DRAFT,
    MSG_ALL,
  } msg_status_t;

#ifdef __cplusplus
}
#endif                          /* __cplusplus */

#endif                          /* LIPS_MSG_TYPES_H */

