/*	libmsgenabler - Library of messaging enabler
 *
 *	Authors: WU Yu <yu.wu@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */



#ifdef __cplusplus
extern "C"
{
#endif                          /* __cplusplus */

#include <glib.h>

#define MAX_BUF_LEN	256
#define MSG_CONF_FILE	"msg_conffile"

#ifndef CONFIGURE_PREFIX
#define CONFIGURE_PREFIX "/usr/local"
#endif

#define PREFIX CONFIGURE_PREFIX "/share/libmsgenabler"

#define ERR_INVALID_ARG -1;
#define	ERR_OPEN_FILE	-2;

  typedef struct
  {
    gchar *conf_file;
    gchar *db_file;
    gchar *msg_tmpl;
    gchar *folder_tmpl;
    gchar *policy_tmpl;
    gchar *tmp_db;
  } msg_conf_t;


  gint _read_msg_conffile (msg_conf_t *conf);
  msg_conf_t *_msg_conf_new ();
  gint _msg_conf_release (msg_conf_t *conf);

  gchar *_get_msg_tmpl_location_alloc ();
  gchar *_get_folder_tmpl_location_alloc ();
  gchar *_get_dbfile_location_alloc ();
  gchar *_get_policy_tmpl_location_alloc ();
  gchar *_get_tmpdb_location_alloc ();
  gchar *_get_tmpdb_location_alloc ();


#ifdef __cplusplus
}
#endif                          /* __cplusplus */

