/*	libmsgenabler - Library of messaging enabler
 *
 *	Authors: WU Yu <yu.wu@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#ifdef __cplusplus
extern "C"
{
#endif                          /* __cplusplus */


#ifndef _GPE_PHONEPANEL_DBUS_H
#define _GPE_PHONEPANEL_DBUS_H

/* for server */
#define PHONE_SERVER_SERVICE "lips.phone.server"
#define PHONE_SERVER_OBJECT "/phone/server/general"
#define PHONE_SERVER_INTERFACE "phone.server.general"
#define PHONE_SERVER_CONNECT "connect"
#define PHONE_SERVER_DISCONNECT "disconnect"
#define PHONE_SERVER_VOICE_OBJECT "/phone/server/voice"
#define PHONE_SERVER_VOICE_INTERFACE "phone.server.voice"
#define PHONE_SERVER_VOICE_METHOD_DIAL "dial"
#define PHONE_SERVER_VOICE_METHOD_HOLD "hold"
#define PHONE_SERVER_VOICE_METHOD_ACCEPT "accept"
#define PHONE_SERVER_VOICE_METHOD_HUANGUP "hungup"
#define PHONE_SERVER_VOICE_METHOD_DTMF "dtmf"
#define PHONE_SERVER_SMS_OBJECT "/phone/server/sms"
#define PHONE_SERVER_SMS_INTERFACE "phone.server.sms"
#define PHONE_SERVER_SMS_METHOD_SEND "SendMessage"
#define PHONE_SERVER_SMS_METHOD_DELETE "DeleteMessage"
#define PHONE_SERVER_PBK_OBJECT "/phone/server/pbk"
#define PHONE_SERVER_PBK_INTERFACE "phone.server.pbk"
#define PHONE_SERVER_PBK_METHOD_READ "readpbk"

/* for client */
#define PHONE_VOICE_SERVICE "lips.voice.service"
#define PHONE_VOICE_OBJECT "/phone/voice/service"
#define PHONE_VOICE_INTERFACE "phone.voice.service"
#define PHONE_VOICE_DELIVER_EVENT     "EventArrived"
#define PHONE_SMS_SERVICE "lips.sms.service"
#define PHONE_SMS_OBJECT "/phone/sms/service"
#define PHONE_SMS_INTERFACE "phone.sms.service"
#define PHONE_SMS_DELIVER_EVENT     "EventArrived"
#define PHONE_PBK_SERVICE "lips.pbk.service"
#define PHONE_PBK_OBJECT "/phone/pbk/service"
#define PHONE_PBK_INTERFACE "phone.pbk.service"
#define PHONE_PBK_DELIVER_EVENT     "EventArrived"

  extern GMainLoop *loop;

  DBusConnection *dbus_init (void);
  void dbus_add_msg_listener (const gchar *interface, const gchar *method,
                              void (*callback) ());
  void dbus_add_msg_listener_mc (const gchar *interface,
                                 const gchar *method, void (*callback) ());

#ifdef __cplusplus
}
#endif                          /* __cplusplus */

#endif

