/*	libmsgenabler - Library of messaging enabler
 *
 *	Authors: WU Yu <yu.wu@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */


#include <record.h>

#include "msgfolder.h"


#ifdef __cplusplus
extern "C"
{
#endif                          /* __cplusplus */


#define FOLDER_MAX_SIZE 256

  struct _msg_folder_t
  {
    msg_fid_t id;
    char *label;
    msg_fid_t parent_id;

        /** the number of children */
    uint32_t children_num;

    msg_folder_type_t folder_flag;

        /**which kind of message is allowed to stored in this folder: 
		mms, sms, im, email,ems, mixed */
    msg_type_t type;

    uint32_t currentsize;
    uint32_t maxbytes;
  };


  int _test_policy_add (msg_status_t msg_status,
                        msg_folder_system_type_t folder_type);

  msg_err_t _policy_discover (msg_sid_t sid, uint32_t *number,
                              msg_disp_policy_t **policy);

  int _add_folder (msg_fid_t pid, msg_folder_t *folder);
  int _record_from_folder (msg_folder_t *folder, Record *record);
  uint32_t _folder_id_generate ();
  int _record_to_folder (Record *record, msg_folder_t *folder);
  int _is_folder_empty (msg_fid_t fid);
  int _remove_folder (msg_fid_t pid, msg_fid_t fid);
  int _add_childnum (msg_fid_t pid, int num);

  msg_err_t _list_children_folder (msg_fid_t folder_id, uint32_t *number,
                                   msg_folder_t ***folderarray);

  msg_err_t _change_message_parent (msg_fid_t from, msg_fid_t to,
                                    msg_msgid_t msgid);

  uint32_t _count_msg_in_folder (msg_fid_t fid, msg_status_t status,
                                 char *db_file);

  uint32_t _count_msg_in_folder_r (msg_fid_t fid, msg_status_t status);
  int _message_dig_from_record (Record *record, msg_message_t *msg);
  int _folder_add_size (msg_fid_t fid, int num);
  uint32_t _message_search_by_refno (uint32_t ref_no, char *db_file);
  uint32_t _msgid_from_refno (uint32_t ref_no);
  msg_err_t _list_message_dig (msg_fid_t fid, uint32_t *number,
                               msg_message_t ***msgarray, char *db_file,
                               msg_mem_t mem_type);

  msg_err_t _message_search (msg_fid_t fid, msg_message_t *match,
                             int *number, msg_message_t ***msgarray,
                             char *db_file, msg_mem_t mem_type);

#ifdef __cplusplus
}
#endif                          /* __cplusplus */

