/*	libmsgenabler - Library of messaging enabler
 *
 *	Authors: WU Yu <yu.wu@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#include <glib.h>
#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <stdlib.h>

#include "id-generate.h"

#define PREFIX_FOLDER "folder"
#define PREFIX_MESSAGE "message"


uint32_t
_id_generate (char *prefix)
{
  char *index_file = NULL;
  FILE *fp = NULL;
  uint32_t index = 0;

  char *env_prefix = getenv ("SMS_CONF_PATH")? getenv("SMS_CONF_PATH"):PREFIX;

  if (strcmp (prefix, PREFIX_FOLDER) == 0)
    index_file = g_strdup_printf ("%s/%s", env_prefix, FOLDER_ID_INDEX);
  else if (strcmp (prefix, PREFIX_MESSAGE) == 0)
    index_file = g_strdup_printf ("%s/%s", env_prefix, MESSAGE_ID_INDEX);
  else
  {
    g_print ("%s: wrong prefix\n", __FUNCTION__);
    return -1;
  }

  if (!g_file_test (index_file, G_FILE_TEST_IS_REGULAR))
  {
    g_print ("%s: index file does not exist\n", __FUNCTION__);
    return -1;
  }

  fp = fopen (index_file, "r+");
  if (!fp)
    return -1;

  fread (&index, sizeof (uint32_t), 1, fp);
  index++;

  rewind (fp);

  fwrite (&index, sizeof (uint32_t), 1, fp);

  fclose (fp);
  g_free (index_file);

  return index;


}


int
_index_file_init (char *prefix, uint32_t number)
{
  FILE *fp = NULL;

  char *index_file = NULL;

  char *env_prefix = getenv ("SMS_CONF_PATH")? getenv("SMS_CONF_PATH"):PREFIX;

  if (strcmp (prefix, PREFIX_FOLDER) == 0)
    index_file = g_strdup_printf ("%s/%s", env_prefix, FOLDER_ID_INDEX);
  else if (strcmp (prefix, PREFIX_MESSAGE) == 0)
    index_file = g_strdup_printf ("%s/%s", env_prefix, MESSAGE_ID_INDEX);
  else
  {
    g_print ("%s: wrong prefix\n", __FUNCTION__);
    return -1;
  }

  fp = fopen (index_file, "w");
  if (!fp)
    return -1;


  fwrite (&number, sizeof (uint32_t), 1, fp);

  fclose (fp);

  return 0;
}

