/*	libmsgenabler - Library of messaging enabler
 *
 *	Authors: WU Yu <yu.wu@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#ifndef __LIPS_MSG_ERROR_H
#define __LIPS_MSG_ERROR_H

#ifdef __cplusplus
extern "C"
{
#endif                          /* __cplusplus */

  typedef enum
  {
    MSG_ERROR_NONE = 0,
    MSG_ERROR_INVALID_ARG = -3001,
    MSG_ERROR_MEM_ALLOC = -3002,
    MSG_ERROR_DB_MANIPULATE = -3003,
    MSG_ERROR_SEND_MESSAGE = -3004,
    MSG_ERROR_OPEN_FILE = -3006,
    MSG_ERROR_READ_CONF_FILE = -3007,
    MSG_ERROR_HAS_CHILD = -3008,
    MSG_ERROR_FOLDER_HAS_CHILD = -3009,
    MSG_ERROR_STORE_MESSAGE = -3010,
    MSG_ERROR_ADD_MSG_TO_FLD = -3011,
    MSG_ERROR_NO_SUCH_RECORD = -3012,
    MSG_ERROR_DEL_MSG_FROM_FLD = -3013,
    MSG_ERROR_WRONG_PARENT = -3014,
    MSG_ERROR_FOLDER_OUT_RANGE = -3015,
    MSG_ERROR_DELETE_MESSAGE = -3016,
    MSG_ERROR_FOLDER_NOT_EMPTY = -3017,
    MSG_ERROR_UPDATE_MESSAGE = -3018,
    MSG_ERROR_HASH_TABLE = -3019,
    MSG_ERROR_EVT_EXIST = -3020,
    MSG_ERROR_EVT_NOT_REGISTERED = -3021,
    MSG_ERROR_DBUS_MANIPULATE = -3022,
    MSG_ERROR_DBUS_CONNECT = -3023,
    MSG_ERROR_EVENT_LOOP = -3024,
    MSG_ERROR_SIM_MANIPULATE = -3025,
  } msg_err_t;


#ifdef __cplusplus
}
#endif                          /* __cplusplus */

#endif                          /* __LIPS_MSG_ERROR_H */

