/*	libmsgenabler - Library of messaging enabler
 *
 *	Authors: WU Yu <yu.wu@orange-ftgroup.com> 
 *	
 *	This software and associated documentation files (the "Software") 
 *	are copyright (C) 2005 LiPS Linux Phone Standards Forum [FranceTelecom] 
 *	All Rights Reserved. 
 *
 *	A copyright license is hereby granted for redistribution and use of 
 *	the Software in source and binary forms, with or without modification, 
 *	provided that the following conditions are met: 
 *	- Redistributions of source code must retain the above copyright notice, 
 *	this copyright license and the following disclaimer. 
 *  - Redistributions in binary form must reproduce the above copyright 
 * 	notice, this copyright license and the following disclaimer in the 
 *	documentation and/or other materials provided with the distribution. 
 *	- Neither the name of LiPS  nor the names of its Members may be used 
 *	to endorse or promote products derived from the Software without 
 *	specific prior written permission. 
 *
 *	A patent license for any Necessary Claims owned by Members of LiPS Forum 
 *	to make, have made, use, import, offer to sell, lease and sell or otherwise 
 *	distribute any implementation compliant with the any specification adopted 
 *	by the LiPS Forumcan be obtained from the respective Members on reasonable 
 *	and non-discriminatory terms and conditions and under reciprocity, as 
 *	regulated in more detail in the Internal Policy of the LiPS Forum. 
 *
 *	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER, ITS MEMBERS AND CONTRIBUTORS 
 *	"AS IS", AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 *	THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
 *	AND NON-INFRINGEMENT ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER, 
 *	ITS MEMBERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 *	PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; 
 *	OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 *	WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 *	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 *	POSSIBILITY OF SUCH DAMAGE. 
 */

#ifndef __LIPS_MSG_EVENT_H
#define __LIPS_MSG_EVENT_H

#include <msgtypes.h>
#include <msgerror.h>

#ifdef __cplusplus
extern "C"
{
#endif                          /* __cplusplus */


/** Event descriptor
*/

  typedef enum
  {
    MSG_EVT_MSG_INCOMING = 1,
    MSG_EVT_MSG_SENT_SUCCESS,
    MSG_EVT_MSG_SENT_FAILED,
    MSG_EVT_MSG_REACH_CONFIRMED,
    MSG_EVT_MSG_REACH_FAILED,
  } msg_evt_type_t;

  typedef struct msg_evt_s msg_evt_t;

  typedef void (*msg_cb_t) (msg_sid_t sid, msg_evt_t *evt);

  struct msg_evt_s
  {
    msg_evt_type_t evt_type;            /**< Event Type */
    msg_cb_t cb;                        /**< Callback */
    void *user_data;                                            /**< Private user data */
    msg_type_t msg_type;                /**< msg type of this evt related msg */
    void *evt_data;                     /**< Event specific data */
  };



/** voice call callback type
*/

/******************evt handling functions*******************
*/

  msg_err_t msg_evt_register (msg_sid_t sid, msg_evt_type_t evt, msg_cb_t cb,
                              void *user_data);
  msg_err_t msg_evt_unregister (msg_sid_t sid, msg_evt_type_t evt);
  msg_err_t msg_evt_process (msg_sid_t sid, int timeout);
  msg_err_t msg_evt_get (msg_sid_t sid, msg_evt_t **evt, int timeout);
  msg_err_t msg_evt_call (msg_sid_t sid, msg_evt_t *evt);
  msg_err_t msg_evt_release (msg_sid_t sid, msg_evt_t *evt);

  msg_err_t _msg_evt_get (msg_sid_t sid, msg_evt_t **evt,
                          msg_evt_type_t evt_type, msg_type_t msg_type,
                          void *event_data);
#ifdef __cplusplus
}
#endif                          /* __cplusplus */

#endif                          /* __LIPS_MSG_EVENT_H */

